// Week13_nearest_point.c
// This program select from a list of points a point that is nearest to the origin. 
#include <stdio.h>
#include <math.h>
#define MAX_PTS 10

int scan_points(int [], int []);
void print_points(int [], int [], int);
int nearest_point(int [], int [], int);

int main(void) {
	int x[MAX_PTS], y[MAX_PTS];
	int num_points, index;

	num_points = scan_points(x, y);
	print_points(x, y, num_points);
	index = nearest_point(x, y, num_points);

	printf("Point nearest to origin: (%d,%d)", x[index], y[index]);
	printf(" with distance %f\n", sqrt(x[index]*x[index] + y[index]*y[index]));

	return 0;
}

// Read the points and return the number of points read.
int scan_points(int x[], int y[]) {
	int size, i;

	printf("Enter number of points (at most %d): ", MAX_PTS);
	scanf("%d", &size);
	for (i=0; i<size; i++) {
		scanf("%d %d", &x[i], &y[i]);
	}
	return size;
}

// Print the points
void print_points(int x[], int y[], int size) {
	int i;

	printf("Points: ");
	for (i=0; i<size; i++) {
		printf("(%d,%d) ", x[i], y[i]);
	}
	printf("\n");
}

// Return the index of the point nearest to the origin
// Precond: size > 0
int nearest_point(int x[], int y[], int size) {
	int i, min_index = 0;
	double min_dist = sqrt(x[0]*x[0] + y[0]*y[0]);
	double dist;

	// printf("0: dist = %f\n", min_dist); // for checking
	for (i=1; i<size; i++) {
		dist = sqrt(x[i]*x[i] + y[i]*y[i]);
		// printf("%d: dist = %f\n", i, dist); // for checking
		if (dist < min_dist) {
			min_dist = dist;
			min_index = i;
		}
	}
	return min_index;
}

