// Week13_washers.c
// This program computes the total weight of a batch of washers.
#include <stdio.h>
#include <math.h>
#define PI 3.14159

double compute_total_weight(double, double, double, double, int);
double circle_area(double);

int main(void) {
	double d1, d2, thickness, density, total_weight; 
	int qty;

	printf("Inner diameter in cm: ");
	scanf("%lf", &d1);
	printf("Outer diameter in cm: ");
	scanf("%lf", &d2);
	printf("Thickness in cm: ");
	scanf("%lf", &thickness);
	printf("Density in grams per cubic cm: ");
	scanf("%lf", &density);
	printf("Quantity: ");
	scanf("%d", &qty);

	total_weight = compute_total_weight(d1, d2, thickness, density, qty);

	printf("Total weight of the batch of %d washers is %.2f grams.\n", 
			qty, total_weight);

	return 0;
}

// Compute total weight of a batch of washers given
// the number of washers, and the washers' data:
// outer diameter, hole diameter, thickness, and density
double compute_total_weight(double d1, double d2, double thickness,
		double density, int qty) {
	double rim_area = circle_area(d2) - circle_area(d1);
	double unit_weight = rim_area * thickness * density;
	return unit_weight * qty;
}

// Returns the area of a circle given its diameter
double circle_area(double diameter) {
	return pow(diameter/2, 2) * PI;
}

